Index: trunk/source/geometry/magneticfield/History
===================================================================
--- trunk/source/geometry/magneticfield/History	(revision 1228)
+++ trunk/source/geometry/magneticfield/History	(revision 1231)
@@ -1,3 +1,3 @@
-$Id: History,v 1.135 2008/11/21 21:16:11 gum Exp $
+$Id: History,v 1.147 2009/11/12 18:45:02 japost Exp $
 -------------------------------------------------------------------
 
@@ -18,6 +18,75 @@
      ----------------------------------------------------------
 
+Nov 12th,  2009 J.Apostolakis - field-V09-02-09
+-----------------------------
+- G4MagIntegratorDriver:  Activate Peter Gumplinger's check on integration
+                          error for spin.
+
+Nov 12th,  2009 J.Apostolakis - field-V09-02-08
+-----------------------------  (fix only)
+- G4Nystrom:  Corrected interface method getField: array now has explicit dimension[4]
+                (Problem found by gcc 4.3 - it checked indices used in inline method! )
+
+Nov 6th,  2009 P.Gumplinger - field-V09-02-07
+---------------------------
+- bug fix in G4EqEMFieldWithSpin and G4EqEMFieldWithEDM
+  thanks to Hiromi Iinuma (KEK) see:
+  http://hypernews.slac.stanford.edu/HyperNews/geant4/get/emfields/161.html
+
+Nov 5th,  2009 J.Apostolakis - field-V09-02-06
+----------------------------
+- G4MagIntegratorDriver.cc : Enabled call to ComputeRightHandSide
+- G4NystromRK4.cc          : Disabled auxiliary code in Stepper (needed if
+                              ComputeRightHandSide is not called.)
+
+Nov 5th,  2009 J.Apostolakis - field-V09-02-05
+----------------------------
+- Added new virtual method CalculateRightHandSide to G4MagIntegratorStepper for use
+      in caching momentum (and field value) by G4NystromRK4
+      Default implementation in G4MagIntegratorStepper calls RightHandSide inline method.
+- G4Nystrom:  New Set/Get method for cache distance.
+              Changed private data members in G4NystromRK4.
+- G4MagIntegratorDriver:  alternative call to ComputeRightHandSide is not used (in comment)
+              As a result G4NystromRK4 operates without reusing 
+
+Nov 5th,  2009 J.Apostolakis - field-V09-02-04
+----------------------------
+- G4CachedMagneticField: New Simple class to cache value of Magnetic Field. 
+     Speeds up code when calculation of field value is complex.
+- G4NystromRK4 :         New Stepper with Nystrom for magnetic field
+     with analytic estimation of integration error.  
+     Greatly reduces number of field value per step.
+- Revised testPropagateMagField to use Cached Quadrupole field,
+     and to cover G4NystromRK4 and G4ConstRK4.
+
+Nov 4th,  2009 P.Gumplinger - field-V09-02-03
+---------------------------
+- (minor change) remove comment from G4EqEMFieldWithSpin.cc
+  add G4EqEMFieldWithEDM class: this is the RHS of EofM in a combined
+  electric and magnetic field, with spin tracking for both MDM and EDM terms.
+  Thanks to Kevin Lynch, Phys. Dept. at Boston University.
+
+May 18th, 2009 T.Nikitina - field-V09-02-02
+-------------------------
+- Enhanced algorithm G4ChordFinder::ApproxCurvePointS() in order to speedup
+  BrentLocator.
+
+March 25th, 2009 G.Cosmo - field-V09-02-01
+------------------------
+- Some code cleanup and formatting...
+
+March 6th, 2009 P.Gumplinger - field-V09-02-00
+----------------------------
+- Added 3rd term of BMT equation (Spin x Beta x Efield) to G4EqEMFieldWithSpin,
+  addresses emfields forum posting #155 (bug report). Thanks to Kevin Lynch,
+  Phys. Dept. at Boston University.
+- Moved renormalization of spin from G4EqEMFieldWithSpin and G4Mag_SpinEqRhs to
+  G4ClassicalRK4 and G4SimpleHeum.
+- Added Spin propagation errors to the criteria for 'OneGoodStep' in
+  G4MagIntegratorDriver but actually don't add it (yet) to the decision logic.
+
 November, 19th, 2008  P.Gumplinger - field-V09-01-05
-- renormalize the spin to ONE in G4EqEMFieldWithSpin.cc and G4Mag_SpinEqRhs.cc
+----------------------------------
+- Renormalized the spin to 1 in G4EqEMFieldWithSpin and G4Mag_SpinEqRhs.
 
 November, 7th, 2008   P.Gumplinger - field-V09-01-04
Index: trunk/source/geometry/magneticfield/include/G4CashKarpRKF45.hh
===================================================================
--- trunk/source/geometry/magneticfield/include/G4CashKarpRKF45.hh	(revision 1228)
+++ trunk/source/geometry/magneticfield/include/G4CashKarpRKF45.hh	(revision 1231)
@@ -26,5 +26,5 @@
 //
 // $Id: G4CashKarpRKF45.hh,v 1.11 2008/01/11 15:23:54 japost Exp $
-// GEANT4 tag $Name: geant4-09-03 $
+// GEANT4 tag $Name:  $
 //
 //
Index: trunk/source/geometry/magneticfield/include/G4ChordFinder.hh
===================================================================
--- trunk/source/geometry/magneticfield/include/G4ChordFinder.hh	(revision 1228)
+++ trunk/source/geometry/magneticfield/include/G4ChordFinder.hh	(revision 1231)
@@ -26,5 +26,5 @@
 //
 // $Id: G4ChordFinder.hh,v 1.21 2008/10/29 14:17:42 gcosmo Exp $
-// GEANT4 tag $Name: geant4-09-03 $
+// GEANT4 tag $Name:  $
 //
 // 
Index: trunk/source/geometry/magneticfield/include/G4ChordFinder.icc
===================================================================
--- trunk/source/geometry/magneticfield/include/G4ChordFinder.icc	(revision 1228)
+++ trunk/source/geometry/magneticfield/include/G4ChordFinder.icc	(revision 1231)
@@ -26,5 +26,5 @@
 //
 // $Id: G4ChordFinder.icc,v 1.14 2008/10/29 14:34:35 gcosmo Exp $
-// GEANT4 tag $Name: geant4-09-03 $
+// GEANT4 tag $Name:  $
 //
 // G4ChordFinder inline implementations
Index: trunk/source/geometry/magneticfield/include/G4ChordFinderSaf.hh
===================================================================
--- trunk/source/geometry/magneticfield/include/G4ChordFinderSaf.hh	(revision 1228)
+++ trunk/source/geometry/magneticfield/include/G4ChordFinderSaf.hh	(revision 1231)
@@ -25,5 +25,5 @@
 //
 // $Id: G4ChordFinderSaf.hh,v 1.4 2008/09/12 16:12:18 gcosmo Exp $
-// GEANT4 tag $Name: geant4-09-03 $
+// GEANT4 tag $Name:  $
 //
 // 
Index: trunk/source/geometry/magneticfield/include/G4ClassicalRK4.hh
===================================================================
--- trunk/source/geometry/magneticfield/include/G4ClassicalRK4.hh	(revision 1228)
+++ trunk/source/geometry/magneticfield/include/G4ClassicalRK4.hh	(revision 1231)
@@ -26,5 +26,5 @@
 //
 // $Id: G4ClassicalRK4.hh,v 1.10 2006/06/29 18:21:55 gunter Exp $
-// GEANT4 tag $Name: geant4-09-03 $
+// GEANT4 tag $Name:  $
 //
 //
Index: trunk/source/geometry/magneticfield/include/G4ConstRK4.hh
===================================================================
--- trunk/source/geometry/magneticfield/include/G4ConstRK4.hh	(revision 1228)
+++ trunk/source/geometry/magneticfield/include/G4ConstRK4.hh	(revision 1231)
@@ -26,5 +26,5 @@
 //
 // $Id: G4ConstRK4.hh,v 1.2 2008/10/29 14:17:42 gcosmo Exp $
-// GEANT4 tag $Name: geant4-09-03 $
+// GEANT4 tag $Name:  $
 //
 // 
Index: trunk/source/geometry/magneticfield/include/G4DELPHIMagField.hh
===================================================================
--- trunk/source/geometry/magneticfield/include/G4DELPHIMagField.hh	(revision 1228)
+++ trunk/source/geometry/magneticfield/include/G4DELPHIMagField.hh	(revision 1231)
@@ -26,5 +26,5 @@
 //
 // $Id: G4DELPHIMagField.hh,v 1.4 2006/06/29 18:21:57 gunter Exp $
-// GEANT4 tag $Name: geant4-09-03 $
+// GEANT4 tag $Name:  $
 //
 //
Index: trunk/source/geometry/magneticfield/include/G4ElectricField.hh
===================================================================
--- trunk/source/geometry/magneticfield/include/G4ElectricField.hh	(revision 1228)
+++ trunk/source/geometry/magneticfield/include/G4ElectricField.hh	(revision 1231)
@@ -26,5 +26,5 @@
 //
 // $Id: G4ElectricField.hh,v 1.2 2006/06/29 18:21:59 gunter Exp $
-// GEANT4 tag $Name: geant4-09-03 $
+// GEANT4 tag $Name:  $
 //
 //
Index: trunk/source/geometry/magneticfield/include/G4ElectroMagneticField.hh
===================================================================
--- trunk/source/geometry/magneticfield/include/G4ElectroMagneticField.hh	(revision 1228)
+++ trunk/source/geometry/magneticfield/include/G4ElectroMagneticField.hh	(revision 1231)
@@ -26,5 +26,5 @@
 //
 // $Id: G4ElectroMagneticField.hh,v 1.11 2006/06/29 18:22:01 gunter Exp $
-// GEANT4 tag $Name: geant4-09-03 $
+// GEANT4 tag $Name:  $
 //
 //
Index: trunk/source/geometry/magneticfield/include/G4EqEMFieldWithSpin.hh
===================================================================
--- trunk/source/geometry/magneticfield/include/G4EqEMFieldWithSpin.hh	(revision 1228)
+++ trunk/source/geometry/magneticfield/include/G4EqEMFieldWithSpin.hh	(revision 1231)
@@ -26,5 +26,5 @@
 //
 // $Id: G4EqEMFieldWithSpin.hh,v 1.3 2008/11/14 13:37:09 gcosmo Exp $
-// GEANT4 tag $Name: geant4-09-03 $
+// GEANT4 tag $Name:  $
 //
 //
Index: trunk/source/geometry/magneticfield/include/G4EqMagElectricField.hh
===================================================================
--- trunk/source/geometry/magneticfield/include/G4EqMagElectricField.hh	(revision 1228)
+++ trunk/source/geometry/magneticfield/include/G4EqMagElectricField.hh	(revision 1231)
@@ -26,5 +26,5 @@
 //
 // $Id: G4EqMagElectricField.hh,v 1.9 2006/06/29 18:22:03 gunter Exp $
-// GEANT4 tag $Name: geant4-09-03 $
+// GEANT4 tag $Name:  $
 //
 //
Index: trunk/source/geometry/magneticfield/include/G4EquationOfMotion.hh
===================================================================
--- trunk/source/geometry/magneticfield/include/G4EquationOfMotion.hh	(revision 1228)
+++ trunk/source/geometry/magneticfield/include/G4EquationOfMotion.hh	(revision 1231)
@@ -26,5 +26,5 @@
 //
 // $Id: G4EquationOfMotion.hh,v 1.10 2006/06/29 18:22:05 gunter Exp $
-// GEANT4 tag $Name: geant4-09-03 $
+// GEANT4 tag $Name:  $
 //
 //
Index: trunk/source/geometry/magneticfield/include/G4EquationOfMotion.icc
===================================================================
--- trunk/source/geometry/magneticfield/include/G4EquationOfMotion.icc	(revision 1228)
+++ trunk/source/geometry/magneticfield/include/G4EquationOfMotion.icc	(revision 1231)
@@ -26,5 +26,5 @@
 //
 // $Id: G4EquationOfMotion.icc,v 1.9 2006/06/29 18:22:07 gunter Exp $
-// GEANT4 tag $Name: geant4-09-03 $
+// GEANT4 tag $Name:  $
 //
 //
Index: trunk/source/geometry/magneticfield/include/G4ErrorMag_UsualEqRhs.hh
===================================================================
--- trunk/source/geometry/magneticfield/include/G4ErrorMag_UsualEqRhs.hh	(revision 1228)
+++ trunk/source/geometry/magneticfield/include/G4ErrorMag_UsualEqRhs.hh	(revision 1231)
@@ -26,5 +26,5 @@
 //
 // $Id: G4ErrorMag_UsualEqRhs.hh,v 1.1 2007/05/16 12:54:02 gcosmo Exp $
-// GEANT4 tag $Name: geant4-09-03 $
+// GEANT4 tag $Name:  $
 //
 //
Index: trunk/source/geometry/magneticfield/include/G4ExactHelixStepper.hh
===================================================================
--- trunk/source/geometry/magneticfield/include/G4ExactHelixStepper.hh	(revision 1228)
+++ trunk/source/geometry/magneticfield/include/G4ExactHelixStepper.hh	(revision 1231)
@@ -25,5 +25,5 @@
 //
 // $Id: G4ExactHelixStepper.hh,v 1.5 2007/05/18 12:50:31 tnikitin Exp $ 
-// GEANT4 tag $Name: geant4-09-03 $
+// GEANT4 tag $Name:  $
 //
 //
Index: trunk/source/geometry/magneticfield/include/G4ExplicitEuler.hh
===================================================================
--- trunk/source/geometry/magneticfield/include/G4ExplicitEuler.hh	(revision 1228)
+++ trunk/source/geometry/magneticfield/include/G4ExplicitEuler.hh	(revision 1231)
@@ -26,5 +26,5 @@
 //
 // $Id: G4ExplicitEuler.hh,v 1.9 2006/06/29 18:22:11 gunter Exp $
-// GEANT4 tag $Name: geant4-09-03 $
+// GEANT4 tag $Name:  $
 //
 //
Index: trunk/source/geometry/magneticfield/include/G4Field.hh
===================================================================
--- trunk/source/geometry/magneticfield/include/G4Field.hh	(revision 1228)
+++ trunk/source/geometry/magneticfield/include/G4Field.hh	(revision 1231)
@@ -26,5 +26,5 @@
 //
 // $Id: G4Field.hh,v 1.10 2006/06/29 18:22:13 gunter Exp $
-// GEANT4 tag $Name: geant4-09-03 $
+// GEANT4 tag $Name:  $
 //
 //
Index: trunk/source/geometry/magneticfield/include/G4FieldManager.hh
===================================================================
--- trunk/source/geometry/magneticfield/include/G4FieldManager.hh	(revision 1228)
+++ trunk/source/geometry/magneticfield/include/G4FieldManager.hh	(revision 1231)
@@ -26,5 +26,5 @@
 //
 // $Id: G4FieldManager.hh,v 1.16 2006/06/29 18:22:15 gunter Exp $
-// GEANT4 tag $Name: geant4-09-03 $
+// GEANT4 tag $Name:  $
 //
 //  
Index: trunk/source/geometry/magneticfield/include/G4FieldManager.icc
===================================================================
--- trunk/source/geometry/magneticfield/include/G4FieldManager.icc	(revision 1228)
+++ trunk/source/geometry/magneticfield/include/G4FieldManager.icc	(revision 1231)
@@ -26,5 +26,5 @@
 //
 // $Id: G4FieldManager.icc,v 1.12 2006/06/29 18:22:18 gunter Exp $
-// GEANT4 tag $Name: geant4-09-03 $
+// GEANT4 tag $Name:  $
 //
 //
Index: trunk/source/geometry/magneticfield/include/G4FieldManagerStore.hh
===================================================================
--- trunk/source/geometry/magneticfield/include/G4FieldManagerStore.hh	(revision 1228)
+++ trunk/source/geometry/magneticfield/include/G4FieldManagerStore.hh	(revision 1231)
@@ -26,5 +26,5 @@
 //
 // $Id: G4FieldManagerStore.hh,v 1.3 2008/01/17 09:39:08 gcosmo Exp $
-// GEANT4 tag $Name: geant4-09-03 $
+// GEANT4 tag $Name:  $
 //
 // class G4FieldManagerStore
Index: trunk/source/geometry/magneticfield/include/G4FieldTrack.hh
===================================================================
--- trunk/source/geometry/magneticfield/include/G4FieldTrack.hh	(revision 1228)
+++ trunk/source/geometry/magneticfield/include/G4FieldTrack.hh	(revision 1231)
@@ -26,5 +26,5 @@
 //
 // $Id: G4FieldTrack.hh,v 1.21 2006/11/13 18:24:35 gcosmo Exp $
-// GEANT4 tag $Name: geant4-09-03 $
+// GEANT4 tag $Name:  $
 //
 //
Index: trunk/source/geometry/magneticfield/include/G4FieldTrack.icc
===================================================================
--- trunk/source/geometry/magneticfield/include/G4FieldTrack.icc	(revision 1228)
+++ trunk/source/geometry/magneticfield/include/G4FieldTrack.icc	(revision 1231)
@@ -26,5 +26,5 @@
 //
 // $Id: G4FieldTrack.icc,v 1.21 2006/11/13 18:24:35 gcosmo Exp $
-// GEANT4 tag $Name: geant4-09-03 $
+// GEANT4 tag $Name:  $
 //
 // -------------------------------------------------------------------
Index: trunk/source/geometry/magneticfield/include/G4HarmonicPolMagField.hh
===================================================================
--- trunk/source/geometry/magneticfield/include/G4HarmonicPolMagField.hh	(revision 1228)
+++ trunk/source/geometry/magneticfield/include/G4HarmonicPolMagField.hh	(revision 1231)
@@ -26,5 +26,5 @@
 //
 // $Id: G4HarmonicPolMagField.hh,v 1.4 2006/06/29 18:22:24 gunter Exp $
-// GEANT4 tag $Name: geant4-09-03 $
+// GEANT4 tag $Name:  $
 //
 // class G4HarmonicPolMagField
Index: trunk/source/geometry/magneticfield/include/G4HelixExplicitEuler.hh
===================================================================
--- trunk/source/geometry/magneticfield/include/G4HelixExplicitEuler.hh	(revision 1228)
+++ trunk/source/geometry/magneticfield/include/G4HelixExplicitEuler.hh	(revision 1231)
@@ -26,5 +26,5 @@
 //
 // $Id: G4HelixExplicitEuler.hh,v 1.9 2007/08/21 08:52:00 tnikitin Exp $
-// GEANT4 tag $Name: geant4-09-03 $
+// GEANT4 tag $Name:  $
 //
 //
Index: trunk/source/geometry/magneticfield/include/G4HelixHeum.hh
===================================================================
--- trunk/source/geometry/magneticfield/include/G4HelixHeum.hh	(revision 1228)
+++ trunk/source/geometry/magneticfield/include/G4HelixHeum.hh	(revision 1231)
@@ -26,5 +26,5 @@
 //
 // $Id: G4HelixHeum.hh,v 1.8 2006/06/29 18:22:36 gunter Exp $
-// GEANT4 tag $Name: geant4-09-03 $
+// GEANT4 tag $Name:  $
 //
 //
Index: trunk/source/geometry/magneticfield/include/G4HelixImplicitEuler.hh
===================================================================
--- trunk/source/geometry/magneticfield/include/G4HelixImplicitEuler.hh	(revision 1228)
+++ trunk/source/geometry/magneticfield/include/G4HelixImplicitEuler.hh	(revision 1231)
@@ -26,5 +26,5 @@
 //
 // $Id: G4HelixImplicitEuler.hh,v 1.8 2006/06/29 18:22:38 gunter Exp $
-// GEANT4 tag $Name: geant4-09-03 $
+// GEANT4 tag $Name:  $
 //
 //
Index: trunk/source/geometry/magneticfield/include/G4HelixSimpleRunge.hh
===================================================================
--- trunk/source/geometry/magneticfield/include/G4HelixSimpleRunge.hh	(revision 1228)
+++ trunk/source/geometry/magneticfield/include/G4HelixSimpleRunge.hh	(revision 1231)
@@ -26,5 +26,5 @@
 //
 // $Id: G4HelixSimpleRunge.hh,v 1.7 2006/06/29 18:22:41 gunter Exp $
-// GEANT4 tag $Name: geant4-09-03 $
+// GEANT4 tag $Name:  $
 //
 //
Index: trunk/source/geometry/magneticfield/include/G4ImplicitEuler.hh
===================================================================
--- trunk/source/geometry/magneticfield/include/G4ImplicitEuler.hh	(revision 1228)
+++ trunk/source/geometry/magneticfield/include/G4ImplicitEuler.hh	(revision 1231)
@@ -26,5 +26,5 @@
 //
 // $Id: G4ImplicitEuler.hh,v 1.8 2006/06/29 18:22:44 gunter Exp $
-// GEANT4 tag $Name: geant4-09-03 $
+// GEANT4 tag $Name:  $
 //
 //
Index: trunk/source/geometry/magneticfield/include/G4LineCurrentMagField.hh
===================================================================
--- trunk/source/geometry/magneticfield/include/G4LineCurrentMagField.hh	(revision 1228)
+++ trunk/source/geometry/magneticfield/include/G4LineCurrentMagField.hh	(revision 1231)
@@ -26,5 +26,5 @@
 //
 // $Id: G4LineCurrentMagField.hh,v 1.4 2006/06/29 18:22:46 gunter Exp $
-// GEANT4 tag $Name: geant4-09-03 $
+// GEANT4 tag $Name:  $
 //
 //
Index: trunk/source/geometry/magneticfield/include/G4LineSection.hh
===================================================================
--- trunk/source/geometry/magneticfield/include/G4LineSection.hh	(revision 1228)
+++ trunk/source/geometry/magneticfield/include/G4LineSection.hh	(revision 1231)
@@ -26,5 +26,5 @@
 //
 // $Id: G4LineSection.hh,v 1.9 2006/06/29 18:22:48 gunter Exp $
-// GEANT4 tag $Name: geant4-09-03 $
+// GEANT4 tag $Name:  $
 //
 //
Index: trunk/source/geometry/magneticfield/include/G4MagErrorStepper.hh
===================================================================
--- trunk/source/geometry/magneticfield/include/G4MagErrorStepper.hh	(revision 1228)
+++ trunk/source/geometry/magneticfield/include/G4MagErrorStepper.hh	(revision 1231)
@@ -26,5 +26,5 @@
 //
 // $Id: G4MagErrorStepper.hh,v 1.11 2006/06/29 18:22:50 gunter Exp $
-// GEANT4 tag $Name: geant4-09-03 $
+// GEANT4 tag $Name:  $
 //
 //
Index: trunk/source/geometry/magneticfield/include/G4MagErrorStepper.icc
===================================================================
--- trunk/source/geometry/magneticfield/include/G4MagErrorStepper.icc	(revision 1228)
+++ trunk/source/geometry/magneticfield/include/G4MagErrorStepper.icc	(revision 1231)
@@ -26,5 +26,5 @@
 //
 // $Id: G4MagErrorStepper.icc,v 1.13 2006/06/29 18:22:52 gunter Exp $
-// GEANT4 tag $Name: geant4-09-03 $
+// GEANT4 tag $Name:  $
 //
 // --------------------------------------------------------------------
Index: trunk/source/geometry/magneticfield/include/G4MagHelicalStepper.hh
===================================================================
--- trunk/source/geometry/magneticfield/include/G4MagHelicalStepper.hh	(revision 1228)
+++ trunk/source/geometry/magneticfield/include/G4MagHelicalStepper.hh	(revision 1231)
@@ -27,5 +27,5 @@
 //
 // $Id: G4MagHelicalStepper.hh,v 1.15 2007/08/21 08:48:28 tnikitin Exp $
-// GEANT4 tag $Name: geant4-09-03 $
+// GEANT4 tag $Name:  $
 //
 //
Index: trunk/source/geometry/magneticfield/include/G4MagHelicalStepper.icc
===================================================================
--- trunk/source/geometry/magneticfield/include/G4MagHelicalStepper.icc	(revision 1228)
+++ trunk/source/geometry/magneticfield/include/G4MagHelicalStepper.icc	(revision 1231)
@@ -26,5 +26,5 @@
 //
 // $Id: G4MagHelicalStepper.icc,v 1.13 2007/05/18 15:45:15 tnikitin Exp $
-// GEANT4 tag $Name: geant4-09-03 $
+// GEANT4 tag $Name:  $
 //
 // Linear Step in regions of no field
Index: trunk/source/geometry/magneticfield/include/G4MagIntegratorDriver.hh
===================================================================
--- trunk/source/geometry/magneticfield/include/G4MagIntegratorDriver.hh	(revision 1228)
+++ trunk/source/geometry/magneticfield/include/G4MagIntegratorDriver.hh	(revision 1231)
@@ -26,5 +26,5 @@
 //
 // $Id: G4MagIntegratorDriver.hh,v 1.20 2007/05/10 10:10:05 japost Exp $
-// GEANT4 tag $Name: geant4-09-03 $
+// GEANT4 tag $Name:  $
 //
 //
Index: trunk/source/geometry/magneticfield/include/G4MagIntegratorDriver.icc
===================================================================
--- trunk/source/geometry/magneticfield/include/G4MagIntegratorDriver.icc	(revision 1228)
+++ trunk/source/geometry/magneticfield/include/G4MagIntegratorDriver.icc	(revision 1231)
@@ -26,5 +26,5 @@
 //
 // $Id: G4MagIntegratorDriver.icc,v 1.13 2007/05/10 10:10:48 japost Exp $
-// GEANT4 tag $Name: geant4-09-03 $
+// GEANT4 tag $Name:  $
 //
 // --------------------------------------------------------------------
Index: trunk/source/geometry/magneticfield/include/G4MagIntegratorStepper.hh
===================================================================
--- trunk/source/geometry/magneticfield/include/G4MagIntegratorStepper.hh	(revision 1228)
+++ trunk/source/geometry/magneticfield/include/G4MagIntegratorStepper.hh	(revision 1231)
@@ -25,5 +25,5 @@
 //
 // $Id: G4MagIntegratorStepper.hh,v 1.14 2009/11/05 18:31:15 japost Exp $
-// GEANT4 tag $Name: geant4-09-03 $
+// GEANT4 tag $Name:  $
 //
 //
Index: trunk/source/geometry/magneticfield/include/G4MagIntegratorStepper.icc
===================================================================
--- trunk/source/geometry/magneticfield/include/G4MagIntegratorStepper.icc	(revision 1228)
+++ trunk/source/geometry/magneticfield/include/G4MagIntegratorStepper.icc	(revision 1231)
@@ -25,5 +25,5 @@
 //
 // $Id: G4MagIntegratorStepper.icc,v 1.12 2009/03/25 15:29:02 gcosmo Exp $
-// GEANT4 tag $Name: geant4-09-03 $
+// GEANT4 tag $Name:  $
 //
 
Index: trunk/source/geometry/magneticfield/include/G4Mag_EqRhs.hh
===================================================================
--- trunk/source/geometry/magneticfield/include/G4Mag_EqRhs.hh	(revision 1228)
+++ trunk/source/geometry/magneticfield/include/G4Mag_EqRhs.hh	(revision 1231)
@@ -26,5 +26,5 @@
 //
 // $Id: G4Mag_EqRhs.hh,v 1.9 2006/06/29 18:23:07 gunter Exp $
-// GEANT4 tag $Name: geant4-09-03 $
+// GEANT4 tag $Name:  $
 //
 //
Index: trunk/source/geometry/magneticfield/include/G4Mag_SpinEqRhs.hh
===================================================================
--- trunk/source/geometry/magneticfield/include/G4Mag_SpinEqRhs.hh	(revision 1228)
+++ trunk/source/geometry/magneticfield/include/G4Mag_SpinEqRhs.hh	(revision 1231)
@@ -26,5 +26,5 @@
 //
 // $Id: G4Mag_SpinEqRhs.hh,v 1.11 2006/06/29 18:23:09 gunter Exp $
-// GEANT4 tag $Name: geant4-09-03 $
+// GEANT4 tag $Name:  $
 //
 //
Index: trunk/source/geometry/magneticfield/include/G4Mag_UsualEqRhs.hh
===================================================================
--- trunk/source/geometry/magneticfield/include/G4Mag_UsualEqRhs.hh	(revision 1228)
+++ trunk/source/geometry/magneticfield/include/G4Mag_UsualEqRhs.hh	(revision 1231)
@@ -26,5 +26,5 @@
 //
 // $Id: G4Mag_UsualEqRhs.hh,v 1.7 2006/06/29 18:23:12 gunter Exp $
-// GEANT4 tag $Name: geant4-09-03 $
+// GEANT4 tag $Name:  $
 //
 //
Index: trunk/source/geometry/magneticfield/include/G4MagneticField.hh
===================================================================
--- trunk/source/geometry/magneticfield/include/G4MagneticField.hh	(revision 1228)
+++ trunk/source/geometry/magneticfield/include/G4MagneticField.hh	(revision 1231)
@@ -26,5 +26,5 @@
 //
 // $Id: G4MagneticField.hh,v 1.14 2006/06/29 18:23:14 gunter Exp $
-// GEANT4 tag $Name: geant4-09-03 $
+// GEANT4 tag $Name:  $
 //
 //
Index: trunk/source/geometry/magneticfield/include/G4QuadrupoleMagField.hh
===================================================================
--- trunk/source/geometry/magneticfield/include/G4QuadrupoleMagField.hh	(revision 1228)
+++ trunk/source/geometry/magneticfield/include/G4QuadrupoleMagField.hh	(revision 1231)
@@ -26,5 +26,5 @@
 //
 // $Id: G4QuadrupoleMagField.hh,v 1.4 2006/06/29 18:23:16 gunter Exp $
-// GEANT4 tag $Name: geant4-09-03 $
+// GEANT4 tag $Name:  $
 //
 //
Index: trunk/source/geometry/magneticfield/include/G4RKG3_Stepper.hh
===================================================================
--- trunk/source/geometry/magneticfield/include/G4RKG3_Stepper.hh	(revision 1228)
+++ trunk/source/geometry/magneticfield/include/G4RKG3_Stepper.hh	(revision 1231)
@@ -27,5 +27,5 @@
 //
 // $Id: G4RKG3_Stepper.hh,v 1.13 2007/05/18 12:44:02 tnikitin Exp $
-// GEANT4 tag $Name: geant4-09-03 $
+// GEANT4 tag $Name:  $
 //
 //
Index: trunk/source/geometry/magneticfield/include/G4SimpleHeum.hh
===================================================================
--- trunk/source/geometry/magneticfield/include/G4SimpleHeum.hh	(revision 1228)
+++ trunk/source/geometry/magneticfield/include/G4SimpleHeum.hh	(revision 1231)
@@ -26,5 +26,5 @@
 //
 // $Id: G4SimpleHeum.hh,v 1.8 2006/06/29 18:23:20 gunter Exp $
-// GEANT4 tag $Name: geant4-09-03 $
+// GEANT4 tag $Name:  $
 //
 //
Index: trunk/source/geometry/magneticfield/include/G4SimpleRunge.hh
===================================================================
--- trunk/source/geometry/magneticfield/include/G4SimpleRunge.hh	(revision 1228)
+++ trunk/source/geometry/magneticfield/include/G4SimpleRunge.hh	(revision 1231)
@@ -26,5 +26,5 @@
 //
 // $Id: G4SimpleRunge.hh,v 1.8 2006/06/29 18:23:23 gunter Exp $
-// GEANT4 tag $Name: geant4-09-03 $
+// GEANT4 tag $Name:  $
 //
 //
Index: trunk/source/geometry/magneticfield/include/G4UniformElectricField.hh
===================================================================
--- trunk/source/geometry/magneticfield/include/G4UniformElectricField.hh	(revision 1228)
+++ trunk/source/geometry/magneticfield/include/G4UniformElectricField.hh	(revision 1231)
@@ -26,5 +26,5 @@
 //
 // $Id: G4UniformElectricField.hh,v 1.9 2006/06/29 18:23:25 gunter Exp $
-// GEANT4 tag $Name: geant4-09-03 $
+// GEANT4 tag $Name:  $
 //
 // 
Index: trunk/source/geometry/magneticfield/include/G4UniformMagField.hh
===================================================================
--- trunk/source/geometry/magneticfield/include/G4UniformMagField.hh	(revision 1228)
+++ trunk/source/geometry/magneticfield/include/G4UniformMagField.hh	(revision 1231)
@@ -26,5 +26,5 @@
 //
 // $Id: G4UniformMagField.hh,v 1.9 2006/06/29 18:23:27 gunter Exp $
-// GEANT4 tag $Name: geant4-09-03 $
+// GEANT4 tag $Name:  $
 //
 // 
Index: trunk/source/geometry/magneticfield/src/G4CashKarpRKF45.cc
===================================================================
--- trunk/source/geometry/magneticfield/src/G4CashKarpRKF45.cc	(revision 1228)
+++ trunk/source/geometry/magneticfield/src/G4CashKarpRKF45.cc	(revision 1231)
@@ -26,5 +26,5 @@
 //
 // $Id: G4CashKarpRKF45.cc,v 1.15 2008/01/11 18:11:44 japost Exp $
-// GEANT4 tag $Name: geant4-09-02-cand-01 $
+// GEANT4 tag $Name:  $
 //
 // The Cash-Karp Runge-Kutta-Fehlberg 4/5 method is an embedded fourth
Index: trunk/source/geometry/magneticfield/src/G4ChordFinder.cc
===================================================================
--- trunk/source/geometry/magneticfield/src/G4ChordFinder.cc	(revision 1228)
+++ trunk/source/geometry/magneticfield/src/G4ChordFinder.cc	(revision 1231)
@@ -25,6 +25,6 @@
 //
 //
-// $Id: G4ChordFinder.cc,v 1.51 2008/10/29 14:17:42 gcosmo Exp $
-// GEANT4 tag $Name: geant4-09-02-cand-01 $
+// $Id: G4ChordFinder.cc,v 1.53 2009/05/18 14:22:43 gcosmo Exp $
+// GEANT4 tag $Name:  $
 //
 //
@@ -432,7 +432,11 @@
   // relative accuracy of each Step.
 
-  G4FieldTrack EndPoint( CurveA_PointVelocity);
-  G4ThreeVector Point_A=CurveA_PointVelocity.GetPosition();
-  G4ThreeVector Point_B=CurveB_PointVelocity.GetPosition();
+  G4FieldTrack EndPoint(CurveA_PointVelocity);
+  if(!first){EndPoint= ApproxCurveV;}
+
+  G4ThreeVector Point_A,Point_B;
+  Point_A=CurveA_PointVelocity.GetPosition();
+  Point_B=CurveB_PointVelocity.GetPosition();
+
   G4double xa,xb,xc,ya,yb,yc;
  
@@ -441,23 +445,30 @@
   if(first)
   {
-      xa=0.;
-      ya=(PointG-Point_A).mag();
-      xb=(Point_A-CurrentF_Point).mag();
-      yb=-(PointG-CurrentF_Point).mag();
-      xc=(Point_A-Point_B).mag();
-      yc=-(CurrentE_Point-Point_B).mag();
+    xa=0.;
+    ya=(PointG-Point_A).mag();
+    xb=(Point_A-CurrentF_Point).mag();
+    yb=-(PointG-CurrentF_Point).mag();
+    xc=(Point_A-Point_B).mag();
+    yc=-(CurrentE_Point-Point_B).mag();
   }    
   else
   {
-     xa=0.;
-     ya=(Point_A-PointG).mag();
-     xb=(Point_B-Point_A).mag();
-     yb=-(PointG-Point_B).mag();
-     xc=-(Point_A-CurrentF_Point).mag();
-     yc=-(Point_A-CurrentE_Point).mag();
-    
-  }
+    xa=0.;
+    ya=(Point_A-CurrentE_Point).mag();
+    xb=(Point_A-CurrentF_Point).mag();
+    yb=(PointG-CurrentF_Point).mag();
+    xc=(Point_A-Point_B).mag();
+    yc=-(Point_B-PointG).mag();
+    if(xb==0.)
+    {
+      EndPoint=
+      ApproxCurvePointV(CurveA_PointVelocity, CurveB_PointVelocity,
+                        CurrentE_Point, eps_step);
+      return EndPoint;
+    }
+  }
+
   const G4double tolerance= 1.e-12;
-  if(ya<=tolerance||std::abs(yc)<=tolerance)
+  if(std::abs(ya)<=tolerance||std::abs(yc)<=tolerance)
   {
     ; // What to do for the moment: return the same point as at start
@@ -475,6 +486,8 @@
     else
     {
+      test_step=(test_step-xb);
       curve=std::abs(EndPoint.GetCurveLength()
                     -CurveB_PointVelocity.GetCurveLength());
+      xb=(CurrentF_Point-Point_B).mag();
     }
       
Index: trunk/source/geometry/magneticfield/src/G4ClassicalRK4.cc
===================================================================
--- trunk/source/geometry/magneticfield/src/G4ClassicalRK4.cc	(revision 1228)
+++ trunk/source/geometry/magneticfield/src/G4ClassicalRK4.cc	(revision 1231)
@@ -25,6 +25,6 @@
 //
 //
-// $Id: G4ClassicalRK4.cc,v 1.12 2006/06/29 18:23:37 gunter Exp $
-// GEANT4 tag $Name: geant4-09-02-cand-01 $
+// $Id: G4ClassicalRK4.cc,v 1.14 2009/03/25 15:29:02 gcosmo Exp $
+// GEANT4 tag $Name:  $
 //
 // -------------------------------------------------------------------
@@ -37,7 +37,7 @@
 // Constructor sets the number of variables (default = 6)
 
-G4ClassicalRK4::G4ClassicalRK4(G4EquationOfMotion* EqRhs, G4int numberOfVariables)
+G4ClassicalRK4::
+G4ClassicalRK4(G4EquationOfMotion* EqRhs, G4int numberOfVariables)
   : G4MagErrorStepper(EqRhs, numberOfVariables)
-    // fNumberOfVariables(numberOfVariables)
 {
    unsigned int noVariables= std::max(numberOfVariables,8); // For Time .. 7+1
@@ -108,5 +108,5 @@
     yOut[i] = yIn[i]+h6*(dydx[i]+dydxt[i]+2.0*dydxm[i]); //+K1/6+K4/6+(K2+K3)/3
   }
-  // NormaliseTangentVector( yOut );
+  if ( nvar == 12 )  { NormalisePolarizationVector ( yOut ); }
   
 }  // end of DumbStepper ....................................................
Index: trunk/source/geometry/magneticfield/src/G4ConstRK4.cc
===================================================================
--- trunk/source/geometry/magneticfield/src/G4ConstRK4.cc	(revision 1228)
+++ trunk/source/geometry/magneticfield/src/G4ConstRK4.cc	(revision 1231)
@@ -26,5 +26,5 @@
 //
 // $Id: G4ConstRK4.cc,v 1.2 2008/10/29 14:17:42 gcosmo Exp $
-// GEANT4 tag $Name: geant4-09-02-cand-01 $
+// GEANT4 tag $Name:  $
 //
 //
